using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Thirdparty.VendorContact.Cqrs;

public record DeleteVendorContactByIdRequest(string Id);

public record DeleteVendorContactByIdCommand(DeleteVendorContactByIdRequest Data) : IRequest<bool>;

public class DeleteVendorContactByIdHandler : IRequestHandler<DeleteVendorContactByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteVendorContactByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteVendorContactByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.VendorContact
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        _context.VendorContact.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}